<template>
  <div>

    <br/>
    <div class="col-md-8">

      <div v-if="honeycollections.toString().length > 3">
        <div class="jumbotron">
          <h3>Zbiory: </h3>

          <div>
            Z tego ula zebrano: <strong>{{ wholeCollection }} litrów pysznego miodu!</strong>
          </div>

          <br/>

          <button class="btn btn-primary mr-1" v-on:click="addHoneyCollection()">Dodaj zbiory</button>

        </div>

        <h2>Zbiory:</h2>

        <div class="row" v-for="honeycollection in honeycollections" v-bind:key="honeycollection.id">
          <div>

            <br/>
            <div>
              <br/>
              <div class="col">
                <h6 class="mb-0">Data: </h6>
              </div>
              <div class="col-sm-9 text-secondary">
                {{ honeycollection.collectionDate }}
              </div>
              <hr>

              <div class="col-sm-3">
                <h6 class="mb-0">Rodzaj: </h6>
              </div>
              <div class="col-sm-9 text-secondary">
                {{ honeycollection.honeyType }}
              </div>
              <hr>

              <div class="col-sm-3">
                <h6 class="mb-0">Ilość: </h6>
              </div>
              <div class="col-sm-9 text-secondary">
                {{ honeycollection.amount }} litrów
              </div>
              <br/>

              <button class="btn btn-secondary mr-1"
                      v-on:click="editHoneyCollection(honeycollection.id)">
                Edytuj zbiór
              </button>
              <button class="btn btn-danger mr-1"
                      v-on:click="deleteHoneyCollection(honeycollection.id)">
                Usuń zbiór
              </button>

            </div>
          </div>
        </div>
      </div>
    </div>


  </div>
</template>

<script>
import HoneycollectionService from "@/services/honeycollection.service";

export default {
  name: "Collections",
  data() {
    return {
      honeycollections: '',
      wholeCollection: ''
    }
  },
  computed: {
    currentUser() {
      return this.$store.state.auth.user;
    }
  },

  mounted() {

    if (this.$route.query.beehiveId) {
      HoneycollectionService.getHoneyCollectionsByBeehiveId(this.$route.query.beehiveId).then(
          response => {
            this.honeycollections = response.data;
          },
          error => {
            this.honeycollections =
                (error.response && error.response.data && error.response.data.message) ||
                error.message ||
                error.toString();
          }
      );

      HoneycollectionService.getAmountOfHoneyByBeehiveId(this.$route.query.beehiveId).then(
          response => {
            this.wholeCollection = response.data;
          },
          error => {
            this.wholeCollection =
                (error.response && error.response.data && error.response.data.message) ||
                error.message ||
                error.toString();
          }
      );

    }

  },
  methods: {

    addHoneyCollection() {
      this.$router.push('/addhoneycollection?beehiveId=' + this.$route.query.beehiveId);
    },

    editHoneyCollection(honeyCollectionId) {
      this.$router.push('/edithoneycollection?honeycollectionId=' + honeyCollectionId + '&beehiveId=' + this.$route.query.beehiveId);
    },

    deleteHoneyCollection(honeyCollectionId) {

      if (confirm("Jesteś pewny?")) {
        HoneycollectionService.deleteSpecificHoneyCollection(honeyCollectionId).then(
            response => {
              this.honeycollections = response.data;
              alert('Usunięcie zbioru przebiegło pomyślnie')
              // eslint-disable-next-line no-unused-vars
              this.$router.push('/beehive?beehiveid=' + this.$route.query.beehiveId).catch(err => {
              });
            },
            error => {
              this.honeycollections =
                  (error.response && error.response.data && error.response.data.message) ||
                  error.message ||
                  error.toString();
            }
        );
      }
    },
  }

}
</script>

<style scoped>

</style>